| EM datagrams on *.kmall format Reg.no. 410224 Revision H

Data Fields
EMdgmSKMinfo_def Struct Reference

Sensor (S) output datagram - info of KMB datagrams. More...

`#include <EMdgmFormat.h>`

## Data Fields
uint16_t | numBytesInfoPart
uint8_t | sensorSystem
uint8_t | sensorStatus
uint16_t | sensorInputFormat
uint16_t | numSamplesArray
uint16_t | numBytesPerSample
uint16_t | sensorDataContents

## Detailed Description

Sensor (S) output datagram - info of KMB datagrams.

Definition at line 237 of file EMdgmFormat.h.

## Field Documentation

## ◆ numBytesInfoPart

uint16_t numBytesInfoPart

Size in bytes of current struct. Used for denoting size of rest of datagram in cases where only one datablock is attached.

Definition at line 241 of file EMdgmFormat.h.

## ◆ sensorSystem

uint8_t sensorSystem

Attitude system number, as numbered in installation parameters. E.g. system 0 referes to system ATTI_1 in installation datagram #IIP.

Definition at line 242 of file EMdgmFormat.h.

## ◆ sensorStatus

uint8_t sensorStatus

Sensor status. Summarise the status fields of all KM binary samples added in this datagram (status in struct KMbinary_def). Only available data from input sensor format is summarised. Available data found in sensorDataContents.
Bits 0 -7 common to all sensors and #MRZ sensor status:

Bit number | Sensor data
--- | ---
0 | 0 = Data OK 1 = Data OK and sensor is chosen as active
1 | 0
2 | 0 = Data OK 1 = Reduced performance
3 | 0
4 | 0 = Data OK 1 = Invalid data
5 | 0
6 | 0 = Velocity from sensor 1 = Velocity calculated by PU

Definition at line 243 of file EMdgmFormat.h.

## ◆ sensorInputFormat

uint16_t sensorInputFormat

Format of raw data from input sensor, given in numerical code according to table below.

Code | Sensor format
--- | ---
1 | KM binary Sensor Input
2 | EM 3000 data
3 | Sagem
4 | Seapath binary 11
5 | Seapath binary 23
6 | Seapath binary 26
7 | POS M/V GRP 102/103
8 | Coda Octopus MCOM

Definition at line 259 of file EMdgmFormat.h.

## ◆ numSamplesArray

uint16_t numSamplesArray

Number of KM binary sensor samples added in this datagram.

Definition at line 272 of file EMdgmFormat.h.

## ◆ numBytesPerSample

uint16_t numBytesPerSample

Length in bytes of one whole KM binary sensor sample.

Definition at line 273 of file EMdgmFormat.h.

## ◆ sensorDataContents

uint16_t sensorDataContents

Field to indicate which information is available from the input sensor, at the given sensor format.
0 = not available
1 = data is available
The bit pattern is used to detemine sensorStatus from status field in #KMB samples. Only data available from sensor is check up against invalid/reduced performance in status, and summaries in sensorStatus.
E.g. the binary 23 format does not contain delayed heave. This is indicated by setting bit 6 in sensorDataContents to 0. In each sample in #KMB output from PU, the status field (struct KMbinary_def) for INVALID delayed heave (bit 6) is set to 1. The summaries sensorStatus in struct EMdgmSKMinfo_def will then be sets to 0 if all available data is ok.
Expected data field in sensor input:

Bit number | Sensor data
--- | ---
0 | Horizontal position and velocity
1 | Roll and pitch
2 | Heading
3 | Heave and vertical velocity
4 | Acceleration
5 | Error fields
6 | Delayed heave

Definition at line 274 of file EMdgmFormat.h.

The documentation for this struct was generated from the following file:

- EMdgmFormat.h